//	Zinc Application Framework - D_PRINT.CPP
//	COPYRIGHT (C) 1990-1998.  All Rights Reserved.
//	Zinc Software Incorporated.  Pleasant Grove, Utah  USA

// This file provided as a stub for the personal version of ZAF.

#include <z_print.hpp>

#define ZAF_PRINTER_INFO
#include "gbl_def.cpp"

ZafPrinter::ZafPrinter() :
	ZafDisplay(), printerType(ZAF_POSTSCRIPT_2_PRINTER)
{
}

ZafPrinter::~ZafPrinter(void)
{
}

ZafError ZafPrinter::ColorInfo(ZafLogicalColor, ZafUInt8 &, ZafUInt8 &, ZafUInt8 &)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::FontInfo(ZafLogicalFont, char *,
	int, int *, ZafFontWeight *,
	ZafFontSlant *)
{
	return (ZAF_ERROR_NONE);
}

void ZafPrinter::EmitForeground()
{
}

void ZafPrinter::EmitBackground()
{
}

void ZafPrinter::EmitLineAttributes(int)
{
}

void ZafPrinter::EmitImage(ZafCoordinate, ZafCoordinate,
	double, double, int, int,
	ZafLogicalColor *)
{
}

ZafError ZafPrinter::Bitmap(ZafCoordinate, ZafCoordinate,
	ZafBitmapStruct &)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Icon(ZafCoordinate, ZafCoordinate,
	ZafIconStruct &)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Mouse(ZafCoordinate, ZafCoordinate,
	ZafMouseStruct &)
{
	return (ZAF_ERROR_UNKNOWN);
}

ZafError ZafPrinter::Text(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate, const ZafIChar *,
	int, ZafHzJustify, ZafVtJustify,
	int, bool)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Text(ZafCoordinate, ZafCoordinate,
	const ZafIChar *, int, int,
	bool)
{
	return (ZAF_ERROR_NONE);
}

ZafRegionStruct ZafPrinter::TextSize(const ZafIChar *, int)
{
	ZafRegionStruct region;
	region.coordinateType = ZAF_POINTS;
	region.left = region.top = region.right = region.bottom = 0;

	return (region);
}

ZafError ZafPrinter::Ellipse(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate,
	float, float, int, bool)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Line(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate, int)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Polygon(int, const ZafCoordinate *,
	int, bool, bool)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Rectangle(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate, int, bool)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::RegionCopy(const ZafRegionStruct &, int, int)
{
	return (ZAF_ERROR_UNKNOWN);
}

ZafError ZafPrinter::RectangleXORDiff(const ZafRegionStruct *,
	const ZafRegionStruct *)
{
	return (ZAF_ERROR_UNKNOWN);
}

ZafCoordinate ZafPrinter::TextBlock(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate,
	int &, const ZafIChar *, int,
	ZafHzJustify, ZafVtJustify, bool)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::Pixel(ZafCoordinate, ZafCoordinate,
	ZafLogicalColor, ZafLogicalColor)
{
	return (ZAF_ERROR_NONE);
}

ZafCoordinate ZafPrinter::TextLine(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, const ZafIChar *,
	int, ZafHzJustify, bool)
{
	return (0);
}

ZafLogicalColor ZafPrinter::AddColor(ZafLogicalColor,
	ZafUInt8, ZafUInt8, ZafUInt8)
{
	return (ZAF_CLR_NULL);
}

ZafLogicalFont ZafPrinter::AddFont(ZafLogicalFont, char *,
	int, ZafFontWeight, ZafFontSlant)
{
	return (ZAF_FNT_NULL);
}

ZafError ZafPrinter::DestroyColor(ZafLogicalColor)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::DestroyFont(ZafLogicalFont)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::BeginDraw(OSDisplayContext,
	OSDrawContext, const ZafRegionStruct &,
	const ZafRegionStruct &)
{
	return (ZAF_ERROR_UNKNOWN);
}

ZafError ZafPrinter::EndDraw(void)
{
	return (ZAF_ERROR_UNKNOWN);
}

OSDisplayContext ZafPrinter::DisplayContext(void) const
{
	return (ZAF_NULLH(OSDisplayContext));
}

OSDisplayContext ZafPrinter::SetDisplayContext(OSDisplayContext)
{
	return (ZAF_NULLH(OSDisplayContext));
}

OSDisplayContext ZafPrinter::RestoreDisplayContext(void)
{
	return (ZAF_NULLH(OSDisplayContext));
}

OSDrawContext ZafPrinter::DrawContext(void) const
{
	return (ZAF_NULLH(OSDrawContext));
}

OSDrawContext ZafPrinter::SetDrawContext(OSDrawContext)
{
	return (ZAF_NULLH(OSDrawContext));
}

OSDrawContext ZafPrinter::RestoreDrawContext(void)
{
	return (ZAF_NULLH(OSDrawContext));
}

ZafCoordinate ZafPrinter::PageWidth(void) const
{
	return (0);
}

ZafCoordinate ZafPrinter::PageHeight(void) const
{
	return (0);
}

ZafCoordinate ZafPrinter::PaperWidth(void) const
{
	return (0);
}

ZafCoordinate ZafPrinter::PaperHeight(void) const
{
	return (0);
}

void ZafPrinter::Margins(ZafCoordinate &, ZafCoordinate &,
	ZafCoordinate &, ZafCoordinate &) const
{
}

ZafPrinterType ZafPrinter::SetPrinterType(ZafPrinterType)
{
	return (ZAF_POSTSCRIPT_2_PRINTER);
}

ZafPaperOrientation ZafPrinter::SetPaperOrientation(ZafPaperOrientation)
{
	return (ZAF_PORTRAIT_ORIENTATION);
}

ZafCoordinate ZafPrinter::SetPaperWidth(ZafCoordinate)
{
	return (0);
}

ZafCoordinate ZafPrinter::SetPaperHeight(ZafCoordinate)
{
	return (0);
}

ZafCoordinate ZafPrinter::SetPageWidth(ZafCoordinate)
{
	return (0);
}

ZafCoordinate ZafPrinter::SetPageHeight(ZafCoordinate)
{
	return (0);
}

void ZafPrinter::SetMargins(ZafCoordinate, ZafCoordinate,
	ZafCoordinate, ZafCoordinate)
{
}

ZafError ZafPrinter::AbortJob(void)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::BeginJob(ZafIChar *)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::BeginPage(void)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::EndJob(void)
{
	return (ZAF_ERROR_NONE);
}

ZafError ZafPrinter::EndPage(void)
{
	return (ZAF_ERROR_NONE);
}

ZafRegionStruct ZafPrinter::SetClipRegion(const ZafRegionStruct &)
{
	ZafRegionStruct region;
	region.coordinateType = ZAF_PIXEL;
	region.left = region.top = region.right = region.bottom = 0;

	return (region);
}

bool ZafPrinter::JobSetup(ZafPrintJobStruct &)
{
	return (false);
}

bool ZafPrinter::PrintSetup(void)
{
	return (false);
}

ZafPrintSetupDialog::ZafPrintSetupDialog(int left, int top,
	ZafPrinter *setPrinter) :
	ZafDialogWindow(left, top, 45, 8), printer(setPrinter)
{
}

ZafEventType ZafPrintSetupDialog::Event(const ZafEventStruct &)
{
	return (S_CONTINUE);
}

ZafEventType ZafPrintDialog::Event(const ZafEventStruct &)
{
	return (S_CONTINUE);
}

ZafPrintDialog::ZafPrintDialog(int left, int top,
	ZafPrinter *setPrinter, ZafPrintJobStruct *setPrintJob) :
	ZafDialogWindow(left, top, 60, 8), printer(setPrinter),
	printJob(setPrintJob), allowModifyCollate(true), allowModifyCopies(true),
	allowModifyRange(true)
{
}

ZafDialogEvent ZafPrintDialog::Control(void)
{
	return (S_DLG_CANCEL);
}

