/*  %kw # %v    %n    %d    %t # */
/* Version # 4    METAWNDO.H    11-Jul-93    10:23:40 # */

/********************************************************************** 
 *     METAWNDO.H  -  MetaWINDOW 'Master' include file list.          *
 *     Defines operating system, compiler, compiler fixups and        *
 *     standard C include files for each compiler. Also manages       *
 *     MetaWINDOW Header include files and defines.                   *
 **********************************************************************
 *     Copyright (c) 1985-1993   Metagraphics Software Corporation    * 
 **********************************************************************/

#ifndef METAWNDOH
#define METAWNDOH

#define MS_DOS 1

/* Auto define our defines based on compiler's self ID macros */

/* detect Instant C Compiler */
#ifdef   InstantC_PM
#define IC16M 1   /* 4.0 */
#endif    

/* detect Metaware C Compiler */
#ifdef   __HIGHC__
#define MetawareC 1   /* 1.7, 2.3, 3.0 */
#endif    

/* detect Micosoft C Compiler */
#ifdef   _MSC_VER
#define MicrosoftC  1   /* 5.0 - 7.0 */
#endif    

/* detect Borland/Turbo Compiler */
#ifdef   __TURBOC__
#define TurboC 1    /* 2.0, 3.0 */
#endif    

/* detect TopSpeed Compiler */
#ifdef   __TSC__
#define TopSpeedC 1   /* 3.02 */
#endif

/* detect Watcom Compiler */
#ifdef   __WATCOMC__
#define WatcomC 1   /* 8.0 - 9.0 */
#endif

/* detect Zortech Compiler */
#ifdef   __ZTC__
#define ZortechCPP  1   /* 1.0, 2.0 */
#endif



/* Compiler Dependent Defines */ 

#ifdef    IC16M       /* Instant C is like Microsoft C (in our book) */
#define  MicrosoftC  1
#endif /*IC16M*/  

#ifdef      MetawareC
#pragma Off (Prototype_override_warnings); 
#endif /*MetawareC*/

#ifdef      ZortechCPP             
#define  putch  putchar
#endif /*ZortechCPP */




#include "metconst.h"      /* Structures & Constants        */
#include "metfonts.h"      /* Font File data structure      */
#include "metports.h"      /* GrafPort & GrafMap structures */  
#include "metextrn.h"      /* Function call prototypes      */

#endif /* METAWNDOH */
/*  End of File - METAWNDO.H  */
